Bug 967985 - ThinkPad T510 Speaker Power Save (no sound from speakers) [NEEDINFO]
ThinkPad T510 Speaker Power Save (no sound from speakers)
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
19
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-28 13:50 EDT by James Perkins
Modified: 2014-03-10 10:43 EDT (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
System Information Manufacturer: LENOVO Product Name: 4384FN1 Version: ThinkPad T510 Wake-up Type: Power Switch SKU Number: Not Specified Family: ThinkPad T510
Last Closed: 2014-03-10 10:43:16 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jforbes: needinfo?


Attachments (Terms of Use)
alsa-info (25.11 KB, text/plain)
2013-10-11 06:10 EDT, p.anderson
no flags Details
pactl list output (16.08 KB, text/plain)
2013-10-11 23:53 EDT, p.anderson
no flags Details
Dif of working vs not working alsa output (5.33 KB, patch)
2013-10-14 04:09 EDT, p.anderson
no flags Details | Diff
alsa-info with kernel-3.11.4-201.fc19.x86_64 (29.92 KB, text/plain)
2013-10-15 16:46 EDT, p.anderson
no flags Details
alsa-info with speakers not working (38.85 KB, text/plain)
2013-10-16 13:14 EDT, James Perkins
no flags Details
alsa-info WITH speakers working (38.85 KB, text/plain)
2013-10-16 13:15 EDT, James Perkins
no flags Details

  None (edit)
Description James Perkins 2013-05-28 13:50:44 EDT
Description of problem:
No sound from speakers. Sometimes immediately after a full reboot speaker sound might work for a few minutes to a few seconds. Mostly no sound at all through the speakers.

This seems to be have started around Fedora 14 which I *think* was around Kernel 3.4.

Version-Release number of selected component (if applicable):
Linux 3.9.4-200.fc18.x86_64 #1 SMP Fri May 24 20:10:49 UTC 2013 x86_64 x86_64 x86_64 GNU/Linux

How reproducible:
Only seems reproducible on specific ThinkPad T510's. A fellow Red Hatter with a ThinkPad T510 4384UM4 does not seem to have this issue. Another coworker with the a T510 4384FM4 also has the same issue.

Steps to Reproduce:
1. Must have a specific ThinkPad T510.

Actual results:
No sound is available through built-in speakers, though the headphone jack does work.

Expected results:
Sound through built-in speakers.


Additional info:
There is a way to temporarily enable executing the following command;
hda-verb /dev/snd/hwC0D0 0x1f SET_POWER_STATE 0

This only works for maybe 30 seconds then the speakers power back off.

There has been some discussion here as well http://markmail.org/message/zqbhcuc2gnxji3s7

I'm happy to help debug if it's needed.
Comment 1 James Perkins 2013-05-28 16:00:20 EDT
I did forget to mention I had an updated version of the IBM BIOS installed and downgraded to the same version I knew was working for someone else. This still did not fix the issue.
Comment 2 Jason Schindler 2013-07-12 00:45:02 EDT
I'm experiencing the same issue on my T510.  Until I read this thread, I didn't know that it worked with headphones.

I jumped on the mailing list/thread linked to above and attempted to pick up the debugging that they were asking for.
Comment 3 James Perkins 2013-07-12 20:00:59 EDT
Excellent thanks! I started to give it a shot, but I'm not familiar enough with debugging Linux OS stuff so any help is appreciated.
Comment 4 Steven Noonan 2013-08-04 02:20:01 EDT
I am having the same problem on my Lenovo ThinkPad X201 (model 3680), with BIOS v1.40. I agree this is likely a firmware problem, as this system was working fine before a firmware upgrade a few weeks back. I've also seen this issue repro across multiple kernel versions (3.0.87, 3.4.55, 3.10.4).

Can someone at RedHat get Lenovo engaged on this issue, please?
Comment 5 Josh Boyer 2013-09-18 16:26:05 EDT
*********** MASS BUG UPDATE **************

We apologize for the inconvenience.  There is a large number of bugs to go through and several of them have gone stale.  Due to this, we are doing a mass bug update across all of the Fedora 19 kernel bugs.

Fedora 19 has now been rebased to 3.11.1-200.fc19.  Please test this kernel update and let us know if you issue has been resolved or if it is still present with the newer kernel.

If you experience different issues, please open a new bug report for those.
Comment 6 James Perkins 2013-09-19 15:41:07 EDT
This did not fix the sound issue. Still no sound from speakers after upgrade to new kernel.
Comment 7 p.anderson 2013-10-11 06:10:20 EDT
Created attachment 810951 [details]
alsa-info

A copy of the alsa-info.sh developed file.  My Lenovo T510 has stopped producing sound through the speakers but as per this bug, thread I can get sound via the headphones.
Comment 8 Raymond 2013-10-11 08:23:05 EDT
http://git.kernel.org/cgit/linux/kernel/git/tiwai/sound.git/commit/?id=29c5fbbcfefba5225a6783683c46c39e10877703

post the output of 

pactl list


pulseaudio need jack detection
Comment 9 p.anderson 2013-10-11 23:53:16 EDT
Created attachment 811507 [details]
pactl list output

Here's the pactl list output.  I'm not sure what you meant by 'pulseaudio need jack detection' as the only response I get from that is:

[root@localhost pja]# pulseaudio need jack detection
E: [pulseaudio] main.c: Too many arguments.

hope this helps.
Comment 10 p.anderson 2013-10-12 16:20:06 EDT
FYI, works fine with kernel-3.11.2-201.fc19.x86_64. It's kernel-3.11.3-201.fc19.x86_64 that seems to be the problem for me.
Comment 11 Raymond 2013-10-12 23:39:14 EDT
pulseaudio module-switch-on-port-available use those headphone Jack detection kcontrol to switch to other port when the current port is not available

is there any reason for you to specify model=thinkpad ? 

as those static model quirk did not create volume controls for speaker and headphone, the headphone Jack control and speaker phantom jack
Comment 12 Raymond 2013-10-12 23:43:42 EDT
diff -u working_alsa_info_output non_working_alsa_info_output
Comment 13 p.anderson 2013-10-14 04:00:58 EDT
(In reply to Raymond from comment #11)
> pulseaudio module-switch-on-port-available use those headphone Jack
> detection kcontrol to switch to other port when the current port is not
> available
> 
> is there any reason for you to specify model=thinkpad ? 
> 
> as those static model quirk did not create volume controls for speaker and
> headphone, the headphone Jack control and speaker phantom jack

I was following the instructions hints here:  http://fedoraproject.org/wiki/How_to_debug_sound_problems that lead me to create /etc/modprobe.d/sound.conf with model=thinkpad in it.  Doesn't seem to have had any effect.
Comment 14 p.anderson 2013-10-14 04:09:36 EDT
Created attachment 811909 [details]
Dif of working vs not working alsa output
Comment 15 p.anderson 2013-10-15 04:09:17 EDT
Sound restored as of kernel-3.11.4-201.fc19.x86_64
Comment 16 Raymond 2013-10-15 05:20:06 EDT
http://git.kernel.org/cgit/linux/kernel/git/tiwai/sound.git/commit/sound/pci/hda/patch_conexant.c?id=bb10b09a8ea10228ef3e56365fae40f1e24e5589

-	SND_PCI_QUIRK(0x17aa, 0x215e, "Lenovo T510", CXT5066_AUTO),


as it use auto parser

post the output of alsa-info.sh without specify any model
Comment 17 Raymond 2013-10-15 05:20:42 EDT
http://git.kernel.org/cgit/linux/kernel/git/tiwai/sound.git/commit/sound/pci/hda/patch_conexant.c?id=bb10b09a8ea10228ef3e56365fae40f1e24e5589

-	SND_PCI_QUIRK(0x17aa, 0x215e, "Lenovo T510", CXT5066_AUTO),


as it use auto parser

post the output of alsa-info.sh without specify any model
Comment 18 p.anderson 2013-10-15 16:46:49 EDT
Created attachment 812682 [details]
alsa-info with kernel-3.11.4-201.fc19.x86_64

Works with Kernel kernel-3.11.4-201.fc19.x86_64
Comment 19 James Perkins 2013-10-15 16:49:21 EDT
Still doesn't work for me in kernel-3.11.4-201.fc19.x86_64, but it hasn't worked since about 3.4.
Comment 20 Raymond 2013-10-15 20:49:30 EDT
/sys/class/sound/hwC0D0/driver_pin_configs:
0x19 0x042110ff
0x1a 0x21a190f0
0x1c 0x212140ff

seem your t510 need pin fixup for dock HP and dock mic

Sysfs Files
!!-----------

/sys/class/sound/hwC0D0/init_pin_configs:
0x19 0x042110f0
0x1a 0x61a190f0
0x1b 0x04a110f0
0x1c 0x612140f0
0x1d 0x40f001f0
0x1e 0x40f001f0
0x1f 0x901701f0
0x20 0x40f001f0
0x22 0x40f001f0
0x23 0x90a601f0


for those who still does not work in kernel-3.11.4-201.fc19.x86_64

take a diff of your alsa info with alsa info in

https://bugzilla.redhat.com/show_bug.cgi?id=967985#c18
Comment 21 James Perkins 2013-10-16 13:13:21 EDT
There are quite a few differences between mine and the info attached, but I'm not sure how relevant it is. I did a diff between the speakers not working and the speakers working. Besides dates the only difference was this one line:

Speakers off:
Power: setting=D3, actual=D3

Speakers on:
Power: setting=D0, actual=D0

Which really makes sense. Something is turning off the power to the speakers. I have no idea what it is, but it seems pretty clear that's the issue. I should qualify that though with I'm not a kernel dev so I could be totally wrong :)
Comment 22 James Perkins 2013-10-16 13:14:46 EDT
Created attachment 813069 [details]
alsa-info with speakers not working
Comment 23 James Perkins 2013-10-16 13:15:31 EDT
Created attachment 813070 [details]
alsa-info WITH speakers working
Comment 24 John Eckersberg 2013-11-12 12:05:16 EST
My T510 with product ID 4384BQ1 does *not* suffer from this issue.
Comment 25 James Perkins 2013-11-12 12:30:36 EST
It doesn't seem to be an issue with the 4384UM4 either, but the 4384FM4 and 4384FN1 do have the issue. I'm not sure what other specific models have the issue. FWIW the two models with the issue were from April and May.

It might be so specific to a particular model it's not worth looking into/fixing. I don't think it's a hardware issue because I can power the speakers back on with a command, but they do power themselves back off. It's just annoying, but not really a huge issue. External speakers and headphones do work with no problems.

I've tried downgrading my bios in hopes maybe it was some power setting in there, but that didn't seem to work.
Comment 26 Tom "spot" Callaway 2013-11-13 10:55:50 EST
Datapoint:

I borrowed a T510 (4384FM4), running Fedora 19 (3.9.5-301.fc19) with BIOS 6MET75WW (1.35), and the audio works fine out of the speakers (alsa-info shows Power: setting=D3).

Updated the BIOS to 6MET92WW (1.52), still works.
Comment 27 Tom "spot" Callaway 2013-11-13 10:56:44 EST
Oh, and I also updated to the latest F19 kernel (3.11.7-200.fc19) and it still worked.
Comment 28 James Perkins 2013-11-13 12:20:01 EST
Uh, well it must be something very random then. I'm on the 1.52 bios and just went through changing every bios power setting I could find with no success. Must just be one of those things. I appreciate the effort.
Comment 29 Tom "spot" Callaway 2013-11-13 12:46:50 EST
Cannot reproduce on a 4384BN5 T510, running 6MET81WW.

Not to be mean, but are you sure you don't just have an alsa channel muted? :)
Comment 30 James Perkins 2013-11-13 13:01:32 EST
Not being mean at all :) Yeah, definitely sure on that. I've run the alsamixer and on the "HDA Intel MID" nothing is muted. I've tried disabling auto-mute with no real success either. Running the command "sudo hda-verb /dev/snd/hwC0D0 0x1f SET_POWER_STATE 0" will get the sound back for say 20 seconds, then the speakers power back down. Sometimes you can hear them power down as well.

When I get a chance I'll try to track down an older version of Fedora, maybe 13, and try to boot from USB and see if I have sound. I definitely know this isn't just a Fedora issue. I tried another distro from a USB when I installed Fedora 19 and had the same issue.
Comment 31 Tom "spot" Callaway 2013-11-13 13:46:23 EST
Tested Fedora 19 on yet another T510 (4313CTU), audio works out of the speakers just fine (BIOS is 6MET81WW).
Comment 32 Raymond 2013-11-14 09:48:45 EST
PCI Soundcards installed in the system
!!--------------------------------------

00:1b.0 Audio device: Intel Corporation 5 Series/3400 Series Chipset High Definition Audio (rev 06)


!!Advanced information - PCI Vendor/Device/Subsystem ID's
!!-------------------------------------------------------

00:1b.0 0403: 8086:3b56 (rev 06)
    Subsystem: 17aa:215e




http://git.kernel.org/cgit/linux/kernel/git/tiwai/sound.git/commit/sound/pci/hda?id=2c1350fdeaefefe1a149d3b083383409f43f0daa
Comment 33 James Perkins 2013-11-14 12:29:27 EST
I tested yesterday on Fedora 20 and Fedora 13 (I couldn't get Fedora 12 to boot). Neither had sound through the speakers, but with Fedora 20 I was able to power it back on with the hda-verb command.

I really don't know what it could be, but it seems to not be as consistent as I thought with the various T510 models. My guess at this point is it's a firmware issue. I know I had sound in Fedora 13 before.

If it can't be duplicated by anyone that knows more than me about how to debug it, then I would suggest we can close it. I'm not sure what else to do that this point. Thanks to all for the help and time to look at it though.
Comment 34 Justin M. Forbes 2014-01-03 17:06:18 EST
*********** MASS BUG UPDATE **************

We apologize for the inconvenience.  There is a large number of bugs to go through and several of them have gone stale.  Due to this, we are doing a mass bug update across all of the Fedora 19 kernel bugs.

Fedora 19 has now been rebased to 3.12.6-200.fc19.  Please test this kernel update (or newer) and let us know if you issue has been resolved or if it is still present with the newer kernel.

If you have moved on to Fedora 20, and are still experiencing this issue, please change the version to Fedora 20.

If you experience different issues, please open a new bug report for those.
Comment 35 Justin M. Forbes 2014-03-10 10:43:16 EDT
*********** MASS BUG UPDATE **************

This bug has been in a needinfo state for more than 1 month and is being closed with insufficient data due to inactivity. If this is still an issue with Fedora 19, please feel free to reopen the bug and provide the additional information requested.

Note You need to log in before you can comment on or make changes to this bug.